
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

float compute_delivery(float *BER, int len, float threshold);
float fec(float ber_scale, int d1, int r1, int r2);
void quicksort(float arr[], int low, int high);

int main(int argc, char *argv[])
{
	float ber_scale = atof(argv[1]);
	int d1 = atoi(argv[2]);
	int r1 = atoi(argv[3]);
	int r2 = atoi(argv[4]);
	
	srand ( time(NULL) );
	
	float del = fec(ber_scale, d1, r1, r2);
	printf("ber_scale = %f, d1 = %d, r1 = %d, r2 = %d\n", ber_scale, d1, r1, r2);
	printf("%f\n", del);
}


float fec(float ber_scale, int d1, int r1, int r2)
{
	float max_delivery = 0;
	int max_bad, max_r2_b, max_r2_g;
	
	for(int bad = 1; bad <= d1; bad ++) {
		for(int r2_b = 1; r2_b <= r2; r2_b ++) {
			
			int r2_g = r2 - r2_b;
			
			// input: BER_data1, BER_fec1, BER_fec2_b, BER_fec2_g
			float *BER_data1 = (float *)malloc(sizeof(float) * d1);
			for(int i = 0; i < d1; i ++) {
				BER_data1[i] = ber_scale * (rand() * 1.0 / RAND_MAX);
			}
			
			float *BER_fec1 = (float *)malloc(sizeof(float) * r1);
			for(int i = 0; i < r1; i ++) {
				BER_fec1[i] = ber_scale * (rand() * 1.0 / RAND_MAX);
			}
			
			float *BER_fec2_b = (float *)malloc(sizeof(float) * r2_b);
			for(int i = 0; i < r2_b; i ++) {
				BER_fec2_b[i] = ber_scale * (rand() * 1.0 / RAND_MAX);
			}
			
			float *BER_fec2_g = (float *)malloc(sizeof(float) * r2_g);
			for(int i = 0; i < r2_g; i ++) {
				BER_fec2_g[i] = ber_scale * (rand() * 1.0 / RAND_MAX);
			}
			
			
			float *BER_data1_sorted = (float *)malloc(sizeof(float) * d1);
			memcpy(BER_data1_sorted, BER_data1, sizeof(float) * d1);
			quicksort(BER_data1_sorted, 0, d1 - 1);
			// for(int i = 0; i < d1; i ++) {
			// 	printf("%f,", BER_data1_sorted[i]);
			// }
			// printf("\n");
			// for(int i = 0; i < d1; i ++) {
			// 	printf("%f,", BER_data1[i]);
			// }
			// printf("\n");
			
			float *BER_data1_good = (float *)malloc(sizeof(float) * (d1 - bad) );
			memcpy(BER_data1_good, BER_data1_sorted, sizeof(float) * (d1 - bad) );
			// printf("%d\n", d1 - bad);
			// for(int i = 0; i < d1; i ++) {
			// 	printf("%f,", BER_data1_sorted[i]);
			// }
			// printf("\n");
			// for(int i = 0; i < d1 - bad; i ++) {
			// 	printf("%f,", BER_data1_good[i]);
			// }
			// printf("\n");
			
			float *BER_data1_bad = (float *)malloc(sizeof(float) * bad);
			memcpy(BER_data1_bad, BER_data1_sorted + (d1 - bad), sizeof(float) * bad);
			// printf("%d\n", bad);
			// for(int i = 0; i < d1; i ++) {
			// 	printf("%f,", BER_data1_sorted[i]);
			// }
			// printf("\n");
			// for(int i = 0; i < bad; i ++) {
			// 	printf("%f,", BER_data1_bad[i]);
			// }
			// printf("\n");
			
			// delivery probability of PHY-layer FEC group
			float *BER_data1_BER_fec1 = (float *)malloc(sizeof(float) * (d1 + r1) );
			memcpy(BER_data1_BER_fec1, BER_data1, sizeof(float) * d1);
			memcpy(BER_data1_BER_fec1 + d1, BER_fec1, sizeof(float) * r1);
			float P1 = compute_delivery(BER_data1_BER_fec1, d1 + r1, r1 / 2.0);
			// delivery probability of MAC-layer FEC group involving bad data symbols in PHY-layer
			float *BER_data1_bad_BER_fec2_b = (float *)malloc(sizeof(float) * (bad + r2_b) );
			memcpy(BER_data1_bad_BER_fec2_b, BER_data1_bad, sizeof(float) * bad);
			memcpy(BER_data1_bad_BER_fec2_b + bad, BER_fec2_b, sizeof(float) * r2_b);
			float P2_b = compute_delivery(BER_data1_bad_BER_fec2_b, bad + r2_b, r2_b / 2.0);
			// delivery probability of MAC-layer FEC group involving good data symbols in PHY-layer
			float *BER_data1_good_BER_fec2_g = (float *)malloc(sizeof(float) * (d1 - bad + r2_g) );
			memcpy(BER_data1_good_BER_fec2_g, BER_data1_good, sizeof(float) * (d1 - bad));
			memcpy(BER_data1_good_BER_fec2_g + d1 - bad, BER_fec2_g, sizeof(float) * r2_g);
			float P2_g = compute_delivery(BER_data1_good_BER_fec2_g, d1 - bad + r2_g, r2_g / 2.0);
			// delivery probability of PHY-layer FEC group after MAC-layer FEC
			float *BER_data12 = (float *)malloc(sizeof(float) * (d1 + r1) );
			for(int i = 0; i < bad; i ++) {
				BER_data12[i] = BER_data1_bad[i] * (1 - P2_b);
			}
			for(int i = bad; i < d1; i ++) {
				BER_data12[i] = BER_data1_good[i - bad] * (1 - P2_g);
			}
			memcpy(BER_data12 + d1, BER_fec1, sizeof(float) * r1);
			float P12 = compute_delivery(BER_data12, d1 + r1, r1 / 2.0);
			
			
			// expected successful data symbols
			float delivery = P1 * d1 + (1 - P1) * P12 * d1 + (1 - P1) * (1 - P12) * (P2_b * bad + P2_g * (d1 - bad) );
			printf("bad = %d, r2_b = %d, delivery = %f\n", bad, r2_b, delivery);
			
			if(delivery > max_delivery) {
				max_delivery = delivery;
				max_bad = bad;
				max_r2_b = r2_b;
				max_r2_g = r2_g;
			}
		}
	}
	
	printf("bad = %d, r2_b = %d, r2_g = %d, delivery = %f\n", max_bad, max_r2_b, max_r2_g, max_delivery);
	
	return max_delivery;
}

float compute_delivery(float *BER, int len, float threshold)
{	
	int n = len;
	
	float mean_Y = 0;
	for(int i = 0; i < n; i ++) {
		mean_Y += BER[i];
	}
	
	float var_Y = 0;
	for(int i = 0; i < n; i ++) {
		var_Y += (BER[i] * (1 - BER[i]) );
	}
	
	float std_Y = sqrt(var_Y);
	
	/**
	 * Chebyshev's inequality:
	 * Prob[Y >= threshold]
	 * = Prob[Y-mean(Y) > threshold - mean(Y)]
	 * = Prob[Y-mean(Y) > k sigma(Y)] <= 1/(1+k^2)
	 * k = (threshold-mean(Y))/sigma(Y) and k > 0
	 **/
	float loss_upperbound;
	if(threshold - mean_Y > 0) {
		float k = (threshold - mean_Y) / std_Y;
		loss_upperbound = 1 / (1 + pow(k, 2) );
	}
	else {
		loss_upperbound = 1;
	}
	
	return 1 - loss_upperbound;
}


void quicksort(float arr[], int low, int high) {
	int i = low;
	int j = high;
	float y = 0;
	/* compare value */
	float z = arr[(low + high) / 2];

	/* partition */
	do {
		/* find member above ... */
		while(arr[i] < z) i++;

		/* find element below ... */
		while(arr[j] > z) j--;

		if(i <= j) {
			/* swap two elements */
			y = arr[i];
			arr[i] = arr[j]; 
			arr[j] = y;
			i++; 
			j--;
		}
	} while(i <= j);

	/* recurse */
	if(low < j) 
		quicksort(arr, low, j);

	if(i < high) 
		quicksort(arr, i, high); 
}
