#include<assert.h>
#include <bitset>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 
#include <iostream>


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdexcept>
#include <stdio.h>

#ifdef HAVE_IO_H
#include <io.h>
#endif
#ifdef O_BINARY
#define OUR_O_BINARY O_BINARY
#else
#define OUR_O_BINARY 0
#endif

#ifdef O_LARGEFILE
#define OUR_O_LARGEFILE O_LARGEFILE
#else
#define OUR_O_LARGEFILE 0
#endif

#define PERFORM_MAC_FEC

using namespace std;

string interleave_std(int *len);
string deinterleave_std(string str, int actual_len);

const int payload = 400;

string s(payload, 'l');

const int total_subcarriers = 48;		     
int Nbpsc = 2;                //qpsk
int C = 16;			
unsigned int sc[total_subcarriers];		// sorted list of subcarriers

const float CSI_THRESHOLD = 5;

// constants reg the new mac layer fec groups that can be formed //
const int MAC_FEC_PROTECT_BITS = 240;					      // max bits that can be protected at MAC layer


// for bit-subcarrier mapping //
int num_bits_mapped[total_subcarriers];           			       // tracks num bits mapped
int *bits_mapped[total_subcarriers][payload/total_subcarriers];                // tracks actual bits mapped



int main()
{
   const unsigned char *data = (const unsigned char*) s.data();
   size_t len = s.size();

#ifdef DEBUG
   for(int i =0; i < len; i++)
   {
	printf("%d ", data[i]);
   } 
 
   printf("\n");
#endif

   if(1)
   {
      int actual_len = 0;
      string interleaved_string_std = interleave_std(&actual_len);
#ifdef PERFORM_MAC_FEC
      final_string_msg = compensatePoorFecGroups(interleaved_string_std, NULL);  
#endif     	
      string deinterleaved_string_std = deinterleave_std(interleaved_string_std, actual_len);
      deinterleaved_string_std = deinterleaved_string_std.substr(0, actual_len);
      assert(deinterleaved_string_std.compare(s) == 0);
   }

   printf("asserted!\n");
 
   return 0;
}

// convert the entire data into bits //
string getBitString(const unsigned char *data, int len)
{
  string orig_s;
  for(int i = 0; i < len; i++)
  {
      bitset<sizeof(unsigned char) * 8> s_bits(data[i]);
      std::string tmp_string = s_bits.to_string<char,char_traits<char>,allocator<char> >();
      orig_s.append(tmp_string);
  }
  return orig_s;
}

// converts a bitstring back into a proper msg //
string getMsg(string str, unsigned char *data)
{
  int s_len = str.length();
  //printf("getMsg: len: %d\n", s_len); fflush(stdout);
  int k = 0;
  for(int i = 0; i < s_len; i=i+8)
  {
      //printf("i: %d, k: %d\n", i, k); fflush(stdout);
      //cout<<"i: "<<i<<" current: "<<str.substr(i,8)<<endl;
      bitset<sizeof(unsigned char)*8> s_bits(str.substr(i, 8));
      //printf("long version: %d\n", s_bits.to_ulong());
      data[k] = (unsigned char) s_bits.to_ulong();
      k++;
  }
  //printf("\n");
  
  string ret_s((const char*) data, k);
  return ret_s;
}

string interleave_std(int *actual_len)
{
   const unsigned char *data = (const unsigned char*) s.data();
   size_t len = s.size();
   unsigned int Ncbps = total_subcarriers;

  std::string orig_s = getBitString(data, len);
#ifdef DEBUG
  cout<<"Bit String (uninterleaved) "<<endl;
  cout<<orig_s<<endl;
#endif
  // perform the interleaving //
  int s_len = orig_s.length();

  *actual_len = s_len;

  if((s_len % Ncbps) != 0)
  {
      printf("len: %d, s_len: %d, Ncbps: %d\n", len, s_len, Ncbps); fflush(stdout);

      int extra_bits = Ncbps - (s_len % Ncbps);
      s_len += extra_bits;

      orig_s = orig_s.append(extra_bits, '0');
  }

  assert((s_len % Ncbps) == 0);
  len = s_len / 8;             // in bytes

  unsigned char interleaved_bitstring[sizeof(unsigned char) * s_len];
  memset(interleaved_bitstring, 0, sizeof(unsigned char) * s_len);

  int s = (Nbpsc/2 > 1) ? Nbpsc/2 : 1;
  int blocks = s_len/Ncbps;
  //assert(s_len % Ncbps == 0);

  int offset = 0;

  // to track the bit-subcarrier mapping //
  int interleaved_bit_pos[s_len];	 	// orig_pos->interleaved_pos
  int orig_bit_pos[s_len];			// interleaved_pos->orig_pos

  for(int b = 0; b < blocks; b++)
  {
      for(int k = 0; k < Ncbps; k++)
      {
          //if((offset + k) > s_len)
          //      break;
          int i = (Ncbps/C)*(k%C) + floor(k/C);
          int j = s * floor(i/s) + (i + Ncbps - (int) floor(C * i/Ncbps))%s;
          interleaved_bitstring[j + offset] = orig_s[k + offset];
	  //printf("j: %d, k: %d\n", j, k); fflush(stdout);

	  interleaved_bit_pos[k+offset] = j + offset;
	  orig_bit_pos[j+offset] = k + offset;	  
      }
      offset += Ncbps;
  }

  // print the original bit to subcarrier mapping - depends on the modulation //
  setBitSubcarrierMapping(interleaved_bit_pos, s_len);

#ifdef DEBUG
  for(int i = 0; i < s_len; i++)
  {
     printf("%c", interleaved_bitstring[i]);
  }
  printf("\n");
#endif

  string tmp_s((const char*) interleaved_bitstring, s_len);
#ifdef DEBUG
  cout<<"interleaved string: "<<endl;
  cout<<tmp_s<<endl;

  cout<<"len: "<<len<<endl;
#endif
  // convert the interleaved bit string back into msg //
  unsigned char *interleaved_data = (unsigned char*) malloc(sizeof(unsigned char) * len);
  memset(interleaved_data, 0, sizeof(unsigned char) * len);
  return getMsg(tmp_s, interleaved_data);
}

string deinterleave_std(string buf, int actual_len)
{
  const unsigned char *data = (const unsigned char*) buf.data();
  size_t len = buf.size();
  unsigned int Ncbps = total_subcarriers; 

  std::string orig_s = getBitString(data, len);
#ifdef DEBUG
  cout<<"Bit String (interleaved): "<<endl;
  cout<<orig_s<<endl;
#endif

  int s_len = orig_s.length();

  unsigned char deinterleaved_bitstring[sizeof(unsigned char) * s_len];
  memset(deinterleaved_bitstring, 0, sizeof(unsigned char) * s_len);
 
  int s = (Nbpsc/2 > 1) ? Nbpsc/2 : 1;
  int blocks = ceil(s_len/Ncbps);
  //assert(s_len % Ncbps == 0);

#ifdef DEBUG
  printf("deinterleave starts.. s: %d Ncbps: %d Nbpsc: %d s_len: %d blocks: %d\n", s, Ncbps, Nbpsc, s_len, blocks);
  fflush(stdout);
#endif

  int offset = 0;
  for(int b = 0; b < blocks; b++)
  {
      for(int j = 0; j < Ncbps; j++)
      {
	  //if((offset + j) > s_len)
	  //	break;
	  int i = s * floor(j/s) + (j + (int) floor(C * j/Ncbps)) % s;
	  int k = C * i - (Ncbps - 1) * floor(C * i/Ncbps);
          deinterleaved_bitstring[k + offset] = orig_s[j + offset];
      }
      offset += Ncbps;
  }

  string tmp_s((const char*) deinterleaved_bitstring, actual_len);
#ifdef DEBUG
  cout<<"deinterleaved string: "<<endl;
  cout<<tmp_s<<endl;
#endif   

  len = actual_len / 8;

  unsigned char *deinterleaved_data = (unsigned char*) malloc(sizeof(unsigned char) * len);
  memset(deinterleaved_data, 0, sizeof(unsigned char) * len);

  return getMsg(tmp_s, deinterleaved_data);
}

/* ./gnuradio/interleaver-opt/qam8/best_sub_bitmap.pl will get the subcarriers sorted by 
 * the decreasing order of their SNR values
 */
void readSortedSubcarriers()
{
   const char *filename1 = "sorted_subcarriers.dat";

   int fd;
   FILE *d_fp;
   if ((fd = open (filename1,
                   O_RDONLY|OUR_O_LARGEFILE,
                   0664)) < 0){
       perror(filename1);
   }else {
       if((d_fp = fdopen (fd, true ? "r" : "rb")) == NULL) {
           fprintf(stderr, "preambles file cannot be opened\n");
           close(fd);
       }
       fprintf(stderr, "subcarriers file opened!\n");
       fread_unlocked(sc, sizeof(unsigned int), total_subcarriers, d_fp);
       d_fp = NULL;
   }

#ifdef DEBUG
   printf("The sorted subcarrier list with their CSI values -- \n");
   for(int i = 0; i < total_subcarriers; i++)
   {
       printf("%d: %f \n", sc[i], csi[sc[i]]);	
   }
   fflush(stdout);
#endif
}

void readCSISubcarriers(float *csi)
{
   const char *filename1 = "csi.dat";

   int fd;
   FILE *d_fp;
   if ((fd = open (filename1,
                   O_RDONLY|OUR_O_LARGEFILE,
                   0664)) < 0){
       perror(filename1);
   }else {
       if((d_fp = fdopen (fd, true ? "r" : "rb")) == NULL) {
           fprintf(stderr, "preambles file cannot be opened\n");
           close(fd);
       }
       fprintf(stderr, "subcarriers file opened!\n");
       fread_unlocked(csi, sizeof(float), total_subcarriers, d_fp);
       d_fp = NULL;
   }

#ifdef DEBUG
   printf("CSI values of subarriers -- \n");
   for(int i = 0; i < total_subcarriers; i++)
   {
       printf("%d ", csi[i]);
   }
   printf("\n"); fflush(stdout);
#endif
}

/*
 * gets the list of the subcarriers whose CSI is below the CSI_THRESHOLD
 */
void getWorstSubcarriers(unsigned int *subcarriers, int *num, float *csi)
{
   *num = 0;
   for(int i = 0; i < total_subcarriers; i++)
   {
	if(csi[sc[i]] < CSI_THRESHOLD)
	{
	    subcarriers[(*num)++] = sc[i];
	}
   }
}

// this is done post-interleaving //
void setBitSubcarrierMapping(int *interleaved_bit_pos, int total_bits)
{
  for(int i = 0; i < total_bits; i++)
  {
      int sym_index = interleaved_bit_pos[i]/Nbpsc;                                         // symbol index
      int sc_index = sym_index%total_subcarriers;                               // subcarrier index
      printf("bit: %d mapped to sc: %d\n", i, interleaved_bit_pos[i], sc_index); fflush(stdout);
      bits_mapped[sc_index][num_bits_mapped[sc_index]++] = interleaved_bit_pos[i];	
  }
}

// this is done pre-interleaving //
void setBitToFecGroupMapping(int *subcarriers, int sc_num, int total_bits)
{
  int num_fec_groups = ceil(total_bits/fec_N);

  int *fec_group_marked = (int*) malloc(sizeof(int) * num_fec_groups);
  memset(fec_group_marked, 0, sizeof(int) * num_fec_groups);

  for(int i = 0; i < sc_num; i++)
  {
      int sc_index = subcarriers[i];	
      int num_bits_on_sc = num_bits_mapped[sc_index];
      for(int j = 0; j < num_bits_on_sc; j++)
      {
	  int interleaved_bit_pos = bits_mapped[sc_index][j];
	  int _orig_bit_pos = orig_bit_pos[interleaved_bit_pos];

          int fec_group_index = _orig_bit_pos/fec_n;
	  if(fec_group_marked[fec_group_index] == 0)
	  {
	      fec_group_marked[fec_group_index] = 1;
	      num_bits_fec_group[fec_group_index] = 0; 		//initialize the new entry
	  }

	  fec_bits[fec_group_index][num_bits_fec_group[fec_group_index]++] = _orig_bit_pos;
      }
  }
  free(fec_group_marked); 
}

/* 
 * utility of a bit = fn(csi_bit, importance to the fec group)
 */
void compensatePoorFecGroups(string s, float *csi)
{
   const unsigned char *data = (const unsigned char*) s.data();
   size_t total_bits = s.size();
   unsigned int Ncbps = total_subcarriers;

  std::string orig_s = getBitString(data, total_bits);
#ifdef DEBUG
  cout<<"Bit String (uninterleaved) "<<endl;
  cout<<orig_s<<endl;
#endif

  // get the bad subcarriers, if their threshold is below a certain value // 
  unsigned int worst_subcarriers[total_subcarriers];
  int num = 0;
  getWorstSubcarriers(worst_subcarriers, &num, csi);

  // get the fec groups that are affected by the bits on the bad subcarriers //  
  setBitToFecGroupMapping(worst_subcarriers, num, total_bits); 
  int num_fec_groups = ceil(total_bits/fec_N);

  // figure out the candidate_bits that need to be protected by mac layer fec // 
  int candidate_bits[MAC_FEC_PROTECT_BITS];

  int num_candidate_bits = 0;					// tracks the bits added to the candidate_bits set
  for(int i = 0; i < num_fec_groups; i++)
  {
     int num_bad_bits_in_group = num_bits_fec_group[i];
     if(num_bad_bits_in_group > THRESHOLD)
     {
	if(num_candidate_bits + num_bad_bits_in_group < MAC_FEC_PROTECT_BITS)
	{
	    memcpy(candidate_bits, fec_bits[i], sizeof(int) * num_bad_bits_in_group);
	    num_candidate_bits += num_bad_bits_in_group;
	}
	else
	{
	    int rem = MAC_FEC_PROTECT_BITS - num_candidate_bits;
	    memcpy(candidate_bits, fec_bits[i], sizeof(int) * rem);	
	    num_candidate_bits += rem;
	    break;
	}
     }
  }

  // form the mac-layer fec groups by grouping the above bits
  int num_parity = 0; 
  short *extra_parity = allocate_mac_fec(candidate_bits, num_candidate_bits, &num_parity);  
  string extra_bits = getBitStringFromShortSymbols(extra_parity, num_parity); 
  s.append(extra_bits);

  return s;  
}

string
getBitStringFromShortSymbols(short *data, int num_symbols)
{
  std::string orig_s;
#ifdef DEBUG_LDPC
  printf("getBitString_LDPC, num_symbols: %d\n", num_symbols); fflush(stdout);
#endif
  for(int i = 0; i < num_symbols; i++)
  {
      std::bitset<sizeof(unsigned char) * 8> s_bits(data[i]);
      std::string tmp_string = s_bits.to_string<char,std::char_traits<char>,std::allocator<char> >();
      orig_s.append(tmp_string.substr(7, 1));
  }
  return orig_s;
}


/* form mac layer fec groups among the 'bits'
 * msg_bits: the bits that need to be protected using the mac fec
 * return val: the parity bits that now need to be appended/interleaved somehow to the outgoing msg
 */
short* allocate_mac_fec(short *msg_bits, int num_candidate_bits, int *num_parity)
{
  int num_mac_fec_groups = num_candidate_bits/K;
  assert(num_candidate_bits % K == 0);				// for now!!!!!!!!	 


  // initialize the LDPC encoder //
  static struct LDPCParam ldpc_param;
  char *filename = "/v/filer4b/v27q002/ut-wireless/Apurv/mac-fec/96.1A3.838.txt";
  FILE *fpLDPC = fopen(filename, "rb");
  LDPC_init(&ldpc_param, fpLDPC);
  if(!fpLDPC)
  {
     printf("LDPC: file cannot be found!\n"); fflush(stdout);
     fflush(stdout);
  }
  else
  {
     printf("LDPC file opened!\n"); fflush(stdout);
  }
  int msgLen = ldpc_param.mat_param[0] - ldpc_param.mat_param[1];
  int codeLen = ldpc_param.mat_param[0];

  if(msgLen != K || codeLen != N)
  {
      printf("msgLen: %d, k: %d, codeLen: %d, n: %d\n", msgLen, K, codeLen, N);	
      assert(false);
  }
  
  // perform LDPC encoding over the chosen bits //
  short *code = (short*) malloc(sizeof(short) * N * num_mac_fec_groups);
  memset(code, 0, sizeof(short) * N * num_mac_fec_groups);

  for(int i = 0; i < num_mac_fec_groups; i++)
  {
     LDPC_encode(ldpc_param.GMatrix, msg_bits + (i*K), code +(i*N), ldpc_param.mat_param);
  }
    

  // the data part of the bits have already been settled into their final interleaved positions; 
  // just dig out the 'extra' parity bits
  short *parity_bits = (short*) malloc(sizeof(short) * (N-K) * num_mac_fec_groups);
  memset(parity_bits, 0, sizeof(short) * (N-K) * num_mac_fec_groups);

  *num_parity = 0;
  for(int i = 0; i < num_mac_fec_groups; i++)
  {
     memcpy(parity_bits + (i*(N-K)), code + (i*K), (N-K)); 
     *num_parity += (N-K);
  }
  free(code);

  return parity_bits;
}
